#include "RTU_Test_Code.h"

/*********************************************************************************************
* Function Test 1: Parsing Request Message
*********************************************************************************************/
void Parsing_Request_Message_Test(void)
{
	char buf[LEN];
	CString name = "Example";
	char s[10] = "";
	int Input1;
	int j = 0;
	int number = GetPrivateProfileInt(name, "Number", 0, TESTPATH3);
	for (int i = 1; i < number + 1; i++)
	{
		memset(buf, 0, sizeof(buf));
		memset(s, 0, sizeof(s));
		_itoa_s(i, s, 10);
		CString name1 = name + s;
		Input1 = GetPrivateProfileString(name1, "Input1", "", buf, LEN, TESTPATH3);

		UINT8 Requst_Message[300];
		UINT8 Response_Message[300];
		string Act_Message = buf;
		const char *b = Act_Message.c_str();
		unsigned int Act_len = 0;
		for (unsigned int i = 0; i + 3 < Act_Message.length(); i = i + 3)
		{
			sscanf_s(b + i, "%02X", (int *)(Requst_Message + Act_len));
			Act_len++;
		}
		sscanf_s(b + Act_Message.length() - 2, "%02X", (int *)(Requst_Message + Act_len));
		//bool Create_Response_Message(UINT8 *Requst_Message, UINT8 *Response_Message, DWORD Read_len)
		bool a = Create_Response_Message(Requst_Message, Response_Message, Act_len+1);
		j++;
		printf("%d---%d\n", j, a);
	}
}

/*********************************************************************************************
* Function Test 2: Create Response Message
*********************************************************************************************/
void Create_Response_Message_Test(void)
{
	char buf[LEN];
	char buf1[LEN];
	CString name = "Example";
	char s[10] = "";
	int Input1, Input2;
	int number = GetPrivateProfileInt(name, "Number", 0, TESTPATH3);
	Init_Coil_Register();
	for (int i = 1; i < number + 1; i++)
	{
		memset(buf, 0, sizeof(buf));
		memset(buf1, 0, sizeof(buf1));
		memset(s, 0, sizeof(s));
		_itoa_s(i, s, 10);
		CString name1 = name + s;
		Input1 = GetPrivateProfileString(name1, "Input1", "", buf, LEN, TESTPATH3);
		Input2 = GetPrivateProfileString(name1, "Output", "", buf1, LEN, TESTPATH3);

		UINT8 Request_Message[300];
		memset(Request_Message, 0, 300);
		string Act_Message = buf;
		const char *b = Act_Message.c_str();
		unsigned int Act_len = 0;
		for (unsigned int i = 0; i + 3 < Act_Message.length(); i = i + 3)
		{
			sscanf_s(b + i, "%02X", (int *)(Request_Message + Act_len));
			Act_len++;
		}
		sscanf_s(b + Act_Message.length() - 2, "%02X", (int *)(Request_Message + Act_len));


		UINT8 Act_Response_Message[300];
		memset(Act_Response_Message, 0, 300);
		unsigned int Act_len1 = 0;
		if (Input2 != 0)
		{
			string Act_Message1 = buf1;
			const char *a = Act_Message1.c_str();
			for (unsigned int i = 0; i + 3 < Act_Message1.length(); i = i + 3)
			{
				sscanf_s(a + i, "%02X", (int *)(Act_Response_Message + Act_len1));
				Act_len1++;
			}
			sscanf_s(a + Act_Message1.length() - 2, "%02X", (int *)(Act_Response_Message + Act_len1));
		}

		UINT8 Response_Message[300];
		memset(Response_Message, 0, 300);
		Create_Response_Message(Request_Message, Response_Message, Act_len + 1);
		printf("%d\n",i);
		for (unsigned int j = 0; j < Act_len1 + 1; j++)
		{
			printf("%02X ", Act_Response_Message[j]);
		}
		printf("\n");
		for (unsigned int m = 0; m < Act_len1 + 1; m++)
		{
			printf("%02X ", Response_Message[m]);
		}
		printf("\n");
		printf("\n");
	}
}