#include "TCP_Test_Code.h"

/*********************************************************************************************
* Function Test 1: Generate request message
*********************************************************************************************/
void Generate_request_message_test(void)
{
	char buf[LEN];
	char buf1[LEN];
	CString name = "Example";
	char s[10] = "";
	int Output, Input1, Input2, Input3;

	int number = GetPrivateProfileInt(name, "Number", 0, TESTPATH1);
	for (int i = 1; i < number + 1; i++)
	{
		memset(buf, 0, sizeof(buf));
		memset(buf1, 0, sizeof(buf1));
		memset(s, 0, sizeof(s));
		_itoa_s(i, s, 10);
		CString name1 = name + s;
		Input1 = GetPrivateProfileInt(name1, "Input1", 0, TESTPATH1);
		Input2 = GetPrivateProfileInt(name1, "Input2", 0, TESTPATH1);
		Input3 = GetPrivateProfileString(name1, "Input3", "", buf, LEN, TESTPATH1);
		Output = GetPrivateProfileString(name1, "Output", "", buf1, LEN, TESTPATH1);

		UINT8 test_Message[300];
		UINT8 Output_Message[300];
		string Write_date = buf;
		string Act_Message = buf1;
		const char *b = Act_Message.c_str();
		unsigned int Act_len = 0;
		for (unsigned int i = 0; i + 3 < Act_Message.length(); i = i + 3)
		{
			sscanf_s(b + i, "%02X", (int *)(Output_Message + Act_len));
			Act_len++;
		}
		sscanf_s(b + Act_Message.length() - 2, "%02X", (int *)(Output_Message + Act_len));

		int len = Crate_TCP_Message(test_Message, Input1, Input2, 0, Write_date);
		for (int j = 0; j < len; j++)
		{
			printf("%02X ", test_Message[j]);
		}
		printf("\n");
		for (int m = 0; m < len; m++)
		{
			printf("%02X ", Output_Message[m]);
		}
		printf("\n");

	}
}

/*********************************************************************************************
* Function Test 2: Analysis response message
*********************************************************************************************/
void Analysis_response_message_test(void)
{
	char buf[LEN];
	char buf1[LEN];
	CString name = "Example";
	char s[10] = "";
	int Input1, Input2;
	int number = GetPrivateProfileInt(name, "Number", 0, TESTPATH2);
	for (int i = 1; i < number + 1; i++)
	{
		memset(buf, 0, sizeof(buf));
		memset(buf1, 0, sizeof(buf1));
		memset(s, 0, sizeof(s));
		_itoa_s(i, s, 10);
		CString name1 = name + s;
		Input1 = GetPrivateProfileString(name1, "Input1", "", buf, LEN, TESTPATH2);
		Input2 = GetPrivateProfileString(name1, "Input2", "", buf1, LEN, TESTPATH2);

		UINT8 Response_Message[300];
		string Act_Message = buf;
		const char *b = Act_Message.c_str();
		unsigned int Act_len = 0;
		for (unsigned int i = 0; i + 3 < Act_Message.length(); i = i + 3)
		{
			sscanf_s(b + i, "%02X", (int *)(Response_Message + Act_len));
			Act_len++;
		}
		sscanf_s(b + Act_Message.length() - 2, "%02X", (int *)(Response_Message + Act_len));


		UINT8 Request_Message[300];
		string Act_Message1 = buf1;
		const char *a = Act_Message1.c_str();
		unsigned int Act_len1 = 0;
		for (unsigned int i = 0; i + 3 < Act_Message1.length(); i = i + 3)
		{
			sscanf_s(a + i, "%02X", (int *)(Request_Message + Act_len1));
			Act_len1++;
		}
		sscanf_s(a + Act_Message1.length() - 2, "%02X", (int *)(Request_Message + Act_len1));
		Analysis_Response_Message(Response_Message, Request_Message, Act_len+1);
	}
}


